﻿package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Point;	
	
	/**
	 * An implementation the sidescroller tutorial described in a 3-part series
	 * on YouTube:
	 * http://www.youtube.com/watch?v=k38YrVxXkSM&NR=1
	 * 
	 * This implementation does not require the Flash IDE.
	 * 
	 * @author Cameron McKay
	 */
	public class Main extends MovieClip 
	{
		private var _startPos:Point;		
		private var _player:Sprite;		
		private var _boundaries:Sprite;
		
		private var _vx:Number = 0;
		private var _vy:Number = 0;
		
		public function Main():void {
			// Assign defaults.
			_startPos = new Point(100, 10);
			
			_player = new Sprite();
			_player.graphics.beginFill(0xff0000);
			_player.graphics.drawRect(-10, -50, 20, 50);
			_player.graphics.endFill();
			_player.x = _startPos.x;
			_player.y = _startPos.y;
			addChild(_player);					
			
			//trace("player.x = " + _player.x + ", player.y = " + _player.y);
			
			_boundaries = new Sprite();
			_boundaries.graphics.beginFill(0x0000ff);
			_boundaries.graphics.drawRect(40, 100, 110, 20);
			_boundaries.graphics.drawRect(100, 150, 110, 20);
			_boundaries.graphics.lineStyle(20, 0x0000ff);
			_boundaries.graphics.moveTo(200, 300);
			_boundaries.graphics.lineTo(500, 100);
			_boundaries.graphics.moveTo(500, 100);
			_boundaries.graphics.lineTo(600, 100);
			_boundaries.graphics.moveTo(800, 200);
			_boundaries.graphics.lineTo(500, 200);
			//_boundaries.graphics.
			_boundaries.graphics.endFill();
			addChild(_boundaries);
			
			// Set the focus for the keyboard input.
			stage.focus = stage;
			
			// Add event listeners.
			this.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
		}		
		
		private function enterFrameHandler(e:Event):void {
			// Pull player down.
			_vy += 2;			
			
			// Move the player.
			_player.x += _vx;
			_player.y += _vy;			
			
			//trace("vx = " + _vx + ", vy = " + _vy);
			//trace("player.x = " + _player.x + ", player.y = " + _player.y);
			
			// Process collisions.
			processCollisions();
			
			// Scroll the stage.
			scrollStage();
		}
		
		private const ARROW_LEFT:uint = 37;
		private const ARROW_UP:uint = 38;
		private const ARROW_RIGHT:uint = 39;
		
		private function keyDownHandler(e:KeyboardEvent):void {
			switch (e.keyCode) {
				case ARROW_LEFT:
					_vx = -7;
					break;
				
				case ARROW_RIGHT:
					_vx = 7;
					break;
							
				case ARROW_UP:
					_vy = -20;
					break;
					
				default:
			}
		}
		
		private function keyUpHandler(e:KeyboardEvent):void  {
			switch (e.keyCode) {
				case ARROW_LEFT:
				case ARROW_RIGHT:
					_vx = 0;
					break;
					
				default:
			}
		}	
		
		private function processCollisions():void {
			// When the player is falling.
			if ( _vy > 0 )
			{
				// Respawn if player fell off stage.
				if ( _player.y > stage.stageHeight ) {
					_player.x = _startPos.x;
					_player.y = _startPos.y;
					_boundaries.x = 0;
					_boundaries.y = 0;
					_vy = 0;
				} 
				// Otherwise, process collisions with boundaries.
				else {
					var collision:Boolean;
					
					do {
						collision = false;
						if (_boundaries.hitTestPoint(_player.x, _player.y, true)) {
							//trace("collision");
							collision = true;
							
							_player.y -= 0.1;
							_vy = 0;
						}
					} while (collision);									
				}				
			}
		}
		
		private function scrollStage():void {
			_boundaries.x += (stage.stageWidth * 0.5) - _player.x;
			_player.x = stage.stageWidth * 0.5;
		}
	}
}